<template>
  <Layout>
    <Sider>
      <div class="version-menu-wrapper">
        <Menu width="auto"
              v-if="!isLoading">
          <Submenu v-for="(value, name) in projectVersions"
                   :name="name"
                   v-bind:key="name">
            <template slot="title">
              {{name}}
            </template>
            <MenuItem v-for="v in value"
                      v-bind:key="v.name"
                      :name="v.name"
                      :to="{ name: 'version', params: { key: v.key, version: v.name } }">
            {{v.name}}
            </MenuItem>
          </Submenu>
        </Menu>
      </div>
    </Sider>
    <Content>
      <router-view />
    </Content>
  </Layout>
</template>

<script>
import axios from "axios"
import moment from "moment"

export default {
  name: "Releases",
  data: () => ({
    isLoading: true,
    projectVersions: {}
  }),
  methods: {
    async getAllProjectsAndVersions() {
      try {
        let projects = await axios.get(this.$baseApiUrl + "/self/projects")
        for await (const a of projects.data) {
          let res = await axios.get(
            this.$baseApiUrl + "/releasenotes/" + a.key + "/versions"
          )
          let versions = res.data.map(b => {
            let versions = new Object()
            versions.key = a.key
            versions.name = b.name
            versions.releaseDate = moment(b.releaseDate, "YYYY-MM-DD")
            return versions
          })
          this.projectVersions[a.name] = versions.sort(
            (a, b) =>
              moment(b.releaseDate).format("YYYYMMDD") -
              moment(a.releaseDate).format("YYYYMMDD")
          )
        }
      } catch (error) {
        console.error(error)
      }
    }
  },
  async mounted() {
    try {
      this.$Spin.show()
      await this.getAllProjectsAndVersions()
      this.isLoading = false
      this.$Spin.hide()
    } catch (error) {
      this.isLoading = false
      this.$Spin.hide()
      console.error(error)
    }
  }
}
</script>

<style>
/* ::-webkit-scrollbar {
  width: 10px;
}

::-webkit-scrollbar-track {
  box-shadow: inset 0 0 10px 10px green;
  border: solid 3px transparent;
}

::-webkit-scrollbar-thumb {
  box-shadow: inset 0 0 10px 10px red;
  border: solid 3px transparent;
} */
</style>


<style lang="scss" scoped>
//enables scrollbar for versions
.version-menu-wrapper {
  position: fixed;
  width: 200px;
  max-height: calc(100vh - (60px));
  overflow: auto;
  left: 0;
}
</style>

